package com.tanpu.community.controller;


import com.tanpu.common.api.CommonResp;
import com.tanpu.community.api.beans.qo.CommentQo;
import com.tanpu.community.api.beans.req.comment.CreateCommentReq;
import com.tanpu.community.api.beans.req.comment.QueryCommentReq;
import com.tanpu.community.api.beans.req.page.Page;
import com.tanpu.community.manager.CommentManager;
import com.tanpu.community.util.PageUtils;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@Slf4j
@RequestMapping(value = "/api/theme")
public class CommentController {

    @Autowired
    private CommentManager commentManager;

    @ApiOperation("发表评论")
    @PostMapping(value = "/publishComment")
    @ResponseBody
    public CommonResp<Void> publishCommet(@RequestBody CreateCommentReq req) {
        String userId = "liujm";
        commentManager.comment(req, userId);
        return CommonResp.success();
    }

    @ApiOperation("查看评论")
    @PostMapping(value = "/queryComment")
    @ResponseBody
    public CommonResp<Page<CommentQo>> queryComment(@RequestBody QueryCommentReq req){
        //todo
        String userId = "liujm";
        List<CommentQo> result = commentManager.queryComments(req.getThemeId(),userId);
        return CommonResp.success(PageUtils.page(req.getPage(), result));
    }

    @ApiOperation("点赞评论")
    @GetMapping(value = "/likeComment")
    @ResponseBody
    public CommonResp<Void> likeComment(@RequestParam String commentId){
        //todo
        String userId = "liujm";
        return CommonResp.success();
    }

    @ApiOperation("举报评论")
    @GetMapping(value = "/reportComment")
    @ResponseBody
    public CommonResp<Void>  reportComment(@RequestParam String commentId){
        //todo
        String userId = "liujm";
        return CommonResp.success();
    }
}
